"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _openAnimation = _interopRequireDefault(require("../_util/openAnimation"));

var _CollapsePanel = _interopRequireDefault(require("./CollapsePanel"));

var _collapse = _interopRequireDefault(require("../rc-components/collapse"));

var _LocaleReceiver = _interopRequireDefault(require("../locale-provider/LocaleReceiver"));

var _default = _interopRequireDefault(require("../locale-provider/default"));

var _ConfigContext = _interopRequireDefault(require("../config-provider/ConfigContext"));

var Collapse = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Collapse, _Component);

  var _super = (0, _createSuper2["default"])(Collapse);

  function Collapse() {
    var _this;

    (0, _classCallCheck2["default"])(this, Collapse);
    _this = _super.apply(this, arguments);

    _this.renderExpandIcon = function () {
      var panelProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var expandIcon = _this.props.expandIcon;
      return expandIcon ? expandIcon(panelProps) : null;
    };

    _this.renderExpandTextContent = function () {
      var _classNames;

      var panelProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var locale = arguments.length > 1 ? arguments[1] : undefined;
      var localeCode = arguments.length > 2 ? arguments[2] : undefined;
      var expandIconPositionCof = arguments.length > 3 ? arguments[3] : undefined;
      var customizePrefixCls = _this.props.prefixCls;
      var getPrefixCls = _this.context.getPrefixCls;
      var prefixCls = getPrefixCls('collapse', customizePrefixCls);
      var iconCls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-expand-icon"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-expanded"), panelProps.isActive), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-collapsed"), !panelProps.isActive), _classNames));

      var icon = /*#__PURE__*/_react["default"].createElement("i", {
        className: iconCls
      });

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, expandIconPositionCof === 'left' && icon, panelProps.isActive ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-expand-text"),
        style: {
          minWidth: localeCode === 'zh-cn' ? '0.38rem' : '0.52rem'
        }
      }, locale.fold) : /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-expand-text"),
        style: {
          minWidth: localeCode === 'zh-cn' ? '0.38rem' : '0.52rem'
        }
      }, locale.unfold), expandIconPositionCof === 'right' && icon);
    };

    return _this;
  }

  (0, _createClass2["default"])(Collapse, [{
    key: "render",
    value: function render() {
      var _classNames2,
          _this2 = this;

      var _this$props = this.props,
          customizePrefixCls = _this$props.prefixCls,
          _this$props$className = _this$props.className,
          className = _this$props$className === void 0 ? '' : _this$props$className,
          expandIcon = _this$props.expandIcon,
          bordered = _this$props.bordered,
          expandIconPosition = _this$props.expandIconPosition,
          trigger = _this$props.trigger,
          ghost = _this$props.ghost;
      var _this$context = this.context,
          getPrefixCls = _this$context.getPrefixCls,
          getConfig = _this$context.getConfig;
      var prefixCls = getPrefixCls('collapse', customizePrefixCls);
      var expandIconPositionCof = expandIconPosition || getConfig('collapseExpandIconPosition');
      var expandIconCof = expandIcon || getConfig('collapseExpandIcon');
      var triggerCof = trigger || getConfig('collapseTrigger');
      var collapseClassName = (0, _classnames["default"])((_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-borderless"), !bordered), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-text-action"), expandIconCof === 'text' && expandIconPositionCof === 'left'), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-trigger"), triggerCof === 'header'), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-ghost"), ghost), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-icon-position-").concat(expandIconPositionCof), true), _classNames2), className);
      var expandIconContent;

      if (typeof expandIconCof === 'function') {
        expandIconContent = function expandIconContent(panelProps) {
          return _this2.renderExpandIcon(panelProps);
        };
      } else if (expandIconCof === 'text') {
        expandIconContent = function expandIconContent(panelProps) {
          return /*#__PURE__*/_react["default"].createElement(_LocaleReceiver["default"], {
            componentName: "Collapse",
            defaultLocale: _default["default"].Collapse
          }, function (locale, localeCode) {
            return _this2.renderExpandTextContent(panelProps, locale, localeCode, expandIconPositionCof);
          });
        };
      }

      return /*#__PURE__*/_react["default"].createElement(_collapse["default"], (0, _extends2["default"])({}, this.props, {
        expandIcon: expandIconContent,
        expandIconPosition: expandIconPositionCof,
        prefixCls: prefixCls,
        className: collapseClassName
      }));
    }
  }], [{
    key: "contextType",
    get: function get() {
      return _ConfigContext["default"];
    }
  }]);
  return Collapse;
}(_react.Component);

exports["default"] = Collapse;
Collapse.displayName = 'Collapse';
Collapse.Panel = _CollapsePanel["default"];
Collapse.defaultProps = {
  bordered: true,
  openAnimation: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, _openAnimation["default"]), {}, {
    appear: function appear() {}
  })
};
//# sourceMappingURL=Collapse.js.map
