import { ReactNode } from 'react';
import { FormField, FormFieldProps, RenderProps } from '../field/FormField';
import { CurrencyProps } from '../currency/Currency';
import Field from '../data-set/Field';
export interface OutputProps extends FormFieldProps<any>, CurrencyProps<any> {
    renderEmpty?: () => ReactNode;
}
export default class Output extends FormField<OutputProps> {
    static displayName: string;
    static __PRO_OUTPUT: boolean;
    static defaultProps: {
        suffixCls: string;
        readOnly: boolean;
        disabled: boolean;
        noValidate: boolean;
        trim: import("../data-set/enum").FieldTrim;
    };
    isEditable(): boolean;
    useFocusedClassName(): boolean;
    handleChange(): void;
    getOmitPropsKeys(): string[];
    getOtherPropsExcludeOutput(otherProps: any): any;
    getWrapperClassNamesExcludeOutput(): undefined;
    getObservablePropsExcludeOutput(): undefined;
    getValueKey(value: any): any;
    processValue(value: any): ReactNode;
    defaultRenderer(renderProps: RenderProps): ReactNode;
    /**
     * 多行单元格渲染
     */
    renderMultiLine(field: Field): ReactNode;
    getRenderedValue(): ReactNode;
    showTooltip(e: any): boolean;
    renderWrapper(): ReactNode;
}
