import { AxiosRequestConfig } from 'axios';
import { DataSetProps } from '../../../data-set/interface';
export declare const ConditionDataSet: () => DataSetProps;
export declare const QuickFilterDataSet: ({ searchCode, queryDataSet, tableFilterAdapter }: {
    searchCode: any;
    queryDataSet: any;
    tableFilterAdapter: any;
}) => {
    paging: boolean;
    autoQuery: boolean;
    autoLocateFirst: boolean;
    primaryKey: string;
    transport: {
        adapter: (config: AxiosRequestConfig, type: string) => AxiosRequestConfig;
    };
    fields: ({
        name: string;
        label: string;
        type: string;
        maxLength: number;
        required: boolean;
        falseValue?: undefined;
        trueValue?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
    } | {
        name: string;
        type: string;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        label: string;
        maxLength?: undefined;
        required?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
    } | {
        name: string;
        type: string;
        defaultValue: any;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
        transformResponse?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        defaultValue: number;
        transformResponse: (value: any) => 1 | 0;
        label: string;
        maxLength?: undefined;
        required?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
    })[];
};
